      PROGRAM interp
C
CCC---------------------------------------------------------------------
CCC
CCC                       SUBROUTINE OPADTA
CCC                     ******************
CCC
CCC  PURPOSE :
CCC  ---------
CCC     Interpolate data on the ORCA grid
CCC
CC----------------------------------------------------------------------
CC
      IMPLICIT NONE
CC
CC MODEL DATA SIZE
CC ---------------
CC      JPK     : NUMBER OF VERTICAL LEVELS
CC
      INTEGER JPK,JPIDTA,JPJDTA,JPMDTA
CC ORIGINAL GEOPHYSICAL DATA on LEVITUS grid
CC ----------------------------------
CC
CC      JPIDTA  : FIRST HORIZONTAL DIMENSION
CC      JPJDTA  : SECOND
CC      JPMDTA  : NUMBER OF FIELDS TYPE (SALINITY=1)
CC
      PARAMETER(JPIDTA=360,JPJDTA=180,JPK=33,JPMDTA=12)
CC
CC ------------------------------
CC
CC      RDTA    : ORIGINAL ARRAY
CC      RXL     : LONGITUDE ARRAY
CC      RYL     : LATITUDE ARRAY
CC      RTL     : VERTICAL ARRAY
CC      RZL     : TIME ARRAY
CC      SPVAL   : MASK VALUE
CC      RMASK() : MASK FOR ORIGINAL DATA
CC
      REAL ABUND(JPIDTA,JPJDTA,JPK,JPMDTA),
     $   outp(JPIDTA,JPJDTA,JPK,JPMDTA),obse(jpidta,jpjdta,jpk,jpmdta),
     $              RXL(JPIDTA),RYL(JPJDTA),RZL(JPK),RTL(jpmdta),
     $              SPVAL
      REAL RMASK(jpidta,jpjdta)
C
      REAL GDEPT(JPK)
CC FOR NETCDF FILES
CC ----------------
CC
CC ncou : number of output file
CC varid : name of output file
CC vardims : dimensions of output file
C
      INTEGER ncou, maskid, varid(20)
      INTEGER nvdims
      PARAMETER(nvdims=4)
      INTEGER varlat, varlon, vardep, vartim
      INTEGER vardims(nvdims),count(nvdims),start(nvdims)
      INTEGER status
      INCLUDE 'netcdf.inc'
CCC---------------------------------------------------------------------
CCC  OPA7, LODYC (5/11/91)
CCC---------------------------------------------------------------------
C
C 4.1 READ DATA, INTERPOLATE DATA, OUTPUT DATA
C
CCC---------------------------------------------------------------------
CCC
CCC routine antlec
CCC ******************
CCC
CCC PURPOSE :
CCC ---------
CCC READ ORIGINAL DATA
CCC
CC
CC----------------------------------------------------------------------
CC
!      SUBROUTINE profile
CCC---------------------------------------------------------------------
CCC
CCC routine antlec
CCC ******************
CCC
CCC PURPOSE :
CCC ---------
CCC READ ORIGINAL DATA
CCC
CC
CC----------------------------------------------------------------------
CC
!#include "opadta.h"
CCC---------------------------------------------------------------------
CCC OPA, LODYC (5/04/97)
CCC---------------------------------------------------------------------
      INTEGER ji,jj,jk,jm,jn,jla,jlo,length
      REAL varsa
      REAL mask(jpidta,jpjdta,jpk,jpmdta)
      REAL rss,obs,sum,ssq
      CHARACTER*40 filename(5),file
      DATA filename/!"MarEDat20120726Pteropods.nc",
     &"MarEDat20111206Diazotroph.nc",
     &"MarEDat20111206Picophytoplankton.nc",
!     &"MarEDat20120214Bacteria.nc",
!     &"MarEDat20120216Macrozooplankton.nc",
     &"MarEDat20120716Diatoms.nc",
!     &"MarEDat20120424Microzooplankton.nc",
     &"MarEDat20120424Phaeocystis.nc",
     &"MarEDat20120628Coccolithophores.nc"/
!     &"MarEDat20120628Foraminifers.nc",
!     &"MarEDat20120705Mesozooplankton.nc"/

! macro      DATA jjcoor/1,180,1,50,51,75,76,105,106,130,131,180/
C
      DO jn = 1, 5
      obse = 0.
      outp = 0.
      status = nf_open(filename(jn),nf_nowrite,ncou)
      IF (status .NE. 0) STOP 'No data.nc'
      status=nf_inq_varid(ncou,'BIOMASS',varid(1))
      IF (status .NE. 0) STOP 'No variable BIOMASS'
      status=nf_get_var_real(ncou,varid(1),mask)
      status = nf_close(ncou)
      DO jj = 11, jpjdta-10
        DO jm = 1, jpmdta
          DO ji = 11, jpidta-10
            DO jk = 1, jpk
              DO jla = -10,10
                DO jlo = -10,10
                  IF (ABS(mask(ji-jlo,jj-jla,jk,jm)) .LT. 1e14) then
                    obse(ji,jj,jk,jm)=obse(ji,jj,jk,jm)+1.
                    outp(ji,jj,jk,jm)=outp(ji,jj,jk,jm)
     &                +mask(ji-jlo,jj-jla,jk,jm)
                  ENDIF
                END DO
              END DO
              IF (obse(ji,jj,jk,jm).GT.0.5) THEN
                outp(ji,jj,jk,jm)=outp(ji,jj,jk,jm)/obse(ji,jj,jk,jm)
              ELSE
                outp(ji,jj,jk,jm)=-1e35
              ENDIF
            END DO
          END DO
        END DO
      END DO
CCC---------------------------------------------------------------------
CCC
CCC                       ROUTINE dtaout
CCC                     ******************
c
       status = nf_create("fileout.nc",nf_clobber,ncou)
       IF (status .NE. 0) WRITE(*,*)' dtaoutc error create fileout'
c  define attributes
       status = nf_def_dim(ncou,'LONGITUDE',jpidta,vardims(1))
       IF (status .NE. 0) WRITE(*,*)' dtaoutc error dim LON'
       status = nf_def_dim(ncou,'LATITUDE',jpjdta,vardims(2))
       IF (status .NE. 0) WRITE(*,*)' dtaoutc error dim LAT'
       status = nf_def_dim(ncou,'DEPTH',jpk,vardims(3))
       status = nf_def_dim(ncou,'TIME',jpmdta,vardims(4))!jpmdta,vardims(4))
c                                                         
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  define variables
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      status=nf_def_var(ncou,'OBSERVATIONS',nf_float,4,vardims,varid(1))
!       IF (status .NE. 0) WRITE(*,*)' dtaoutc error def pro'
      status = nf_def_var(ncou,'BIOMASS',nf_float,4,vardims,varid(3))
      status = nf_put_att_text(ncou, varid(3),'units',4,'ug/L')
c  create attributes
C  for coordinates
      status = nf_put_att_real(ncou, varid(3),'_FillValue', nf_float
     &,           1,-1e35)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  end of define mode
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      status = nf_enddef(ncou)
C
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  write data to file
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      status = nf_put_var_real(ncou,varid(1),obse)
!       status = nf_put_var_real(ncou,varid(2),abund)
      IF (status .NE. 0) WRITE(*,*) "error writing data"
      status = nf_put_var_real(ncou,varid(3),outp)
C
      call ncclos (ncou, status)
      IF (status .NE. 0) WRITE(*,*) "error closing file"
      obs=0.
      rss=0.
      sum=0.
      ssq=0.
      DO jj = 11, jpjdta-10
        DO jm = 1, jpmdta
          DO ji = 11, jpidta-10
            DO jk = 1, jpk
              IF (ABS(mask(ji,jj,jk,jm)) .LT. 1e14) then
                rss=rss+(mask(ji,jj,jk,jm)-outp(ji,jj,jk,jm))**2
                sum=sum+mask(ji,jj,jk,jm)
                ssq=ssq+mask(ji,jj,jk,jm)**2
                obs=obs+1.
              ENDIF
            END DO
          END DO
        END DO
      END DO
      file=filename(jn)
      length=len(trim(file))
      write(*,*) file(16:length-3),SQRT(rss/(obs-1))*obs/sum,obs
      END DO
      END
