      SUBROUTINE dtaoutc
CCC---------------------------------------------------------------------
CCC
CCC                       ROUTINE dtaout
CCC                     ******************
CCC
CCC  PURPOSE :
CCC  ---------
CCC     WRITE OUTPUT DATA IN NETCDF FORMAT
CCC
CC----------------------------------------------------------------------
#include "opadta.h"
      INTEGER KL,ji,jj,jl,jm
CC
CCC---------------------------------------------------------------------
CCC  OPA7, LODYC (5/11/91)
CCC---------------------------------------------------------------------
C
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  open the netCDF file
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
       status = nf_create("fileout.nc",nf_clobber,ncou)
       IF (status .NE. 0) WRITE(*,*)' dtaoutc error create fileout'
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  define attributes
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
       status = nf_def_dim(ncou,'LONGITUDE',jpidta,vardims(1))
       IF (status .NE. 0) WRITE(*,*)' dtaoutc error dim LON'
       status = nf_def_dim(ncou,'LATITUDE',jpjdta,vardims(2))
       IF (status .NE. 0) WRITE(*,*)' dtaoutc error dim LAT'
       status = nf_def_dim(ncou,'DEPTH',jpk,vardims(3))
       status = nf_def_dim(ncou,'TIME',jpmdta,vardims(4))!jpmdta,vardims(4))
c                                                         
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  define variables
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      status=nf_def_var(ncou,'LONGITUDE',nf_float,1,vardims(1),varlon)
      status=nf_def_var(ncou,'LATITUDE',nf_float,1,vardims(2),varlat)
      status=nf_def_var(ncou,'DEPTH',nf_float,1,vardims(3),vardep)
      status=nf_def_var(ncou,'TIME',nf_float,1,vardims(4),vartim)
      status=nf_def_var(ncou,'OBSERVATIONS',nf_float,4,vardims,varid(1))
      status = nf_def_var(ncou,'ABUNDANCE',nf_float,4,vardims,varid(2))
       IF (status .NE. 0) WRITE(*,*)' dtaoutc error def pro'
      status = nf_put_att_text(ncou, varid(2),'units',2,'/L')
      status = nf_def_var(ncou,'BIOMASS',nf_float,4,vardims,varid(3))
      status = nf_put_att_text(ncou, varid(3),'units',4,'ug/L')
      status=nf_def_var(ncou,'MEDIAN_ABUND',nf_float,4,vardims,varid(4))
      status = nf_put_att_text(ncou, varid(4),'units',2,'/L')
      status=nf_def_var(ncou,'MEDIAN_BIOM',nf_float,4,vardims,varid(5))
      status = nf_put_att_text(ncou, varid(5),'units',4,'ug/L')
      status=nf_def_var(ncou,'STDEV_ABUND',nf_float,4,vardims,varid(6))
      status=nf_def_var(ncou,'STDEV_BIOM',nf_float,4,vardims,varid(7))
      status=nf_def_var(ncou,'NON_ZERO_OBS',nf_float,4,vardims,varid(8))
      status=nf_def_var(ncou,'NON_ZERO_ABUND',nf_float,4,vardims,
     &  varid(9))
      status = nf_put_att_text(ncou, varid(9),'units',2,'/L')
      status = nf_def_var(ncou,'NON_ZERO_BIOM',nf_float,4,vardims,
     &  varid(10))
      status = nf_put_att_text(ncou, varid(10),'units',4,'ug/L')
      status=nf_def_var(ncou,'NON_ZERO_MED_ABUND',nf_float,4,vardims,
     &  varid(11))
      status = nf_put_att_text(ncou, varid(11),'units',2,'/L')
      status=nf_def_var(ncou,'NON_ZERO_MED_BIOM',nf_float,4,vardims,
     &  varid(12))
      status = nf_put_att_text(ncou, varid(12),'units',4,'ug/L')
      status=nf_def_var(ncou,'NON_ZERO_STDEV_ABUND',nf_float,4,vardims,
     &  varid(13))
      status=nf_def_var(ncou,'NON_ZERO_STDEV_BIOM',nf_float,4,vardims,
     &  varid(14))
c                                                                    
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  create attributes
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
C  for coordinates
C
       status = nf_put_att_text(ncou, varlon, 'units', 7, 'degrees')
       status = nf_put_att_text(ncou, varlat, 'units', 7, 'degrees')
       status = nf_put_att_text(ncou, vardep, 'units', 6, 'meters')
       status = nf_put_att_text(ncou, vardep, 'positive', 4, 'down')
       status = nf_put_att_text(ncou, vartim, 'units', 21, 'seconds sinc&
     &e 0-01-01')  
       do jm = 1, 14
         status = nf_put_att_real(ncou, varid(jm),'_FillValue', nf_float
     &,           1,spval)
       enddo
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  end of define mode
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
       status = nf_enddef(ncou)
C
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  write data to file
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      status = nf_put_var_real(ncou,varlon,rxl)
      status = nf_put_var_real(ncou,varlat,ryl)
      status = nf_put_var_real(ncou,vardep,gdept)
      status = nf_put_var_real(ncou,vartim,rtl)
C      write(*,*) 'this is time ',rtl
C       do jm = 1, jpmdta
       status = nf_put_var_real(ncou,varid(1),obs)
       status = nf_put_var_real(ncou,varid(2),abund)
       IF (status .NE. 0) WRITE(*,*) "error writing data"
       status = nf_put_var_real(ncou,varid(3),rdta)
       status = nf_put_var_real(ncou,varid(4),meda)
       status = nf_put_var_real(ncou,varid(5),medc)
       status = nf_put_var_real(ncou,varid(6),stda)
       status = nf_put_var_real(ncou,varid(7),stdc)
       status = nf_put_var_real(ncou,varid(8),obsz)
       status = nf_put_var_real(ncou,varid(9),abunz)
       status = nf_put_var_real(ncou,varid(10),rdtz)
       status = nf_put_var_real(ncou,varid(11),medza)
       status = nf_put_var_real(ncou,varid(12),medzc)
       status = nf_put_var_real(ncou,varid(13),stdza)
       status = nf_put_var_real(ncou,varid(14),stdzc)
C       enddo
       write(*,*) 'data written for ',status,rdta(75,75,1,1)
C
C      write(*,*) 'this is longitude ',rxl
C      write(*,*) 'this is latitude ',ryl
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  close the netCDF file
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
C       IF (kl.eq.jpldta) THEN
C         status = nf_put_var_real(ncou,vartim,rtl)
         call ncclos (ncou, status)
       IF (status .NE. 0) WRITE(*,*) "error closing file"
C       ENDIF
      RETURN
      END
